## meshlab 2022.02+dfsg1

=== src/CMakeLists.txt ===
# Copyright 2019, 2020, Collabora, Ltd.
# Copyright 2019, 2021, Visual Computing Lab, ISTI - Italian National Research Council
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.10)
project(MeshLab)

### Build options
option(BUILD_MESHLAB_MINI "Build only common and meshlab - other plugin targets must be set manually" OFF)
option(BUILD_STRICT "Strictly enforce resolution of all symbols" ON)
option(BUILD_WITH_DOUBLE_SCALAR "Use double type instead of float type for scalars" OFF)
option(ENABLE_MESHLAB_DEBUG_LOG_FILE "If enabled, all the logs of MeshLab will be also saved into a log file" OFF)

option(BUILD_ONLY_MESHLAB_LIBRARIES "Build only meshlab-common and plugins" OFF)
option(USE_DEFAULT_BUILD_AND_INSTALL_DIRS "If set to OFF, it expects that you set manually the binary and install directories" ON)

option(MESHLAB_IS_NIGHTLY_VERSION "Nightly version of meshlab will be used instead of ML_VERSION" OFF)

### Dependencies
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/meshlab_global_settings.cmake" NO_POLICY_SCOPE)
include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/meshlab_tools.cmake")

#message(STATUS "Searching for required components")
find_package(OpenGL REQUIRED)

find_package(
	Qt5
	COMPONENTS OpenGL Xml Network
	REQUIRED)
if (Qt5_VERSION VERSION_LESS 5.15.0)
	message(FATAL_ERROR "Minimum supported Qt5 version is 5.15!")
endif()
find_package(OpenMP)
find_package(Threads)

message(STATUS "Searching for required components with bundled fallback")
find_package(GLEW)
find_package(Eigen3)

### Build directories
if (USE_DEFAULT_BUILD_AND_INSTALL_DIRS) # otherwise, we assume that all these dirs are defined in parent dir
	set(MESHLAB_BUILD_DISTRIB_DIR ${CMAKE_CURRENT_BINARY_DIR}/distrib)
	set(MESHLAB_LIB_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR})
	set(MESHLAB_PLUGIN_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/plugins)
	set(MESHLAB_SHADER_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/shaders)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_BUILD_DISTRIB_DIR})

	### Install directories
	if(WIN32 OR APPLE)
		set(INSTALL_TO_UNIX_LAYOUT OFF)
	else()
		set(INSTALL_TO_UNIX_LAYOUT ON)
	endif()
	include(GNUInstallDirs)
	if(INSTALL_TO_UNIX_LAYOUT)
		set(MESHLAB_BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
		set(MESHLAB_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/meshlab)
		set(MESHLAB_PLUGIN_INSTALL_DIR ${MESHLAB_LIB_INSTALL_DIR}/plugins)
		set(MESHLAB_SHADER_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR}/meshlab/shaders)
	elseif(APPLE)
		set(MESHLAB_BIN_INSTALL_DIR .)
		set(MESHLAB_LIB_INSTALL_DIR meshlab.app/Contents/Frameworks)
		set(MESHLAB_PLUGIN_INSTALL_DIR meshlab.app/Contents/PlugIns)
		set(MESHLAB_SHADER_INSTALL_DIR meshlab.app/Contents/shaders)
	else()
		set(MESHLAB_BIN_INSTALL_DIR .)
		set(MESHLAB_LIB_INSTALL_DIR .)
		set(MESHLAB_PLUGIN_INSTALL_DIR plugins)
		set(MESHLAB_SHADER_INSTALL_DIR shaders)
	endif()

	### Install Settings
	if (NOT APPLE)
		set(CMAKE_INSTALL_RPATH $ORIGIN/../${MESHLAB_LIB_INSTALL_DIR};$ORIGIN/../${CMAKE_INSTALL_LIBDIR})
	else()
		SET(CMAKE_INSTALL_RPATH $ORIGIN/../Frameworks)
	endif()

	get_directory_property(hasParent PARENT_DIRECTORY)
	if(hasParent)
		set(MESHLAB_PLUGIN_OUTPUT_DIR ${MESHLAB_PLUGIN_OUTPUT_DIR} PARENT_SCOPE)
		set(MESHLAB_PLUGIN_INSTALL_DIR ${MESHLAB_PLUGIN_INSTALL_DIR} PARENT_SCOPE)
	endif()
endif()

### Enter subdirectories

# VCGLib -- required
if (VCGDIR) # VCGDIR exists - using custom user vcglib path
	if(EXISTS ${VCGDIR})
		add_subdirectory(${VCGDIR} {CMAKE_CURRENT_BINARY_DIR}/vcglib)
		message(STATUS "- VCGLib - using custom VCGDIR path library")
	else()
		set(VCGDIR NOTFOUND)
	endif()
else()
	get_filename_component(VCGDIR "${CMAKE_CURRENT_LIST_DIR}/vcglib" ABSOLUTE)
	if(EXISTS ${VCGDIR})
		add_subdirectory(${VCGDIR})
		message(STATUS "- VCGLib - using bundled source")
	else()
		set(VCGDIR NOTFOUND)
	endif()
endif()
set(VCGDIR "${VCGDIR}")

if(NOT VCGDIR)
	message(FATAL_ERROR "VCGLib not found. Please clone recursively the MeshLab repo.")
else ()
	message(STATUS "- VCGLib directory: " ${VCGDIR})
endif()

# External
set(EXTERNAL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external)
add_subdirectory(${EXTERNAL_DIR})

add_subdirectory(common)

if (NOT BUILD_ONLY_MESHLAB_LIBRARIES)
	add_subdirectory(meshlab)
	if(WIN32 AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/use_cpu_opengl")
		add_subdirectory(use_cpu_opengl)
	endif()

	# Clear RPATH before adding plugins
	set(CMAKE_INSTALL_RPATH)
endif()



### Plugin subdirectories
if(NOT DEFINED MESHLAB_PLUGINS) # it may be already defined in parent directory
	set(MESHLAB_PLUGINS
		# IO plugins
		meshlabplugins/io_3ds
		meshlabplugins/io_base
		meshlabplugins/io_bre
		meshlabplugins/io_collada
		meshlabplugins/io_ctm
		meshlabplugins/io_e57
		meshlabplugins/io_expe
		meshlabplugins/io_gltf
		meshlabplugins/io_json
		meshlabplugins/io_pdb
		meshlabplugins/io_tri
		meshlabplugins/io_txt
		meshlabplugins/io_u3d
		meshlabplugins/io_x3d

		# Filter plugins
		meshlabplugins/filter_sample
		meshlabplugins/filter_createiso
		meshlabplugins/filter_geodesic
		meshlabplugins/filter_sample_gpu
		meshlabplugins/filter_ao
		meshlabplugins/filter_camera
		meshlabplugins/filter_clean
		meshlabplugins/filter_color_projection
		meshlabplugins/filter_colorproc
		meshlabplugins/filter_create
		meshlabplugins/filter_dirt
		meshlabplugins/filter_fractal
		meshlabplugins/filter_func
		meshlabplugins/filter_img_patch_param
		meshlabplugins/filter_icp
		meshlabplugins/filter_io_nxs
		meshlabplugins/filter_isoparametrization
		meshlabplugins/filter_layer
		meshlabplugins/filter_measure
		meshlabplugins/filter_mesh_booleans
		meshlabplugins/filter_meshing
		meshlabplugins/filter_mls
		meshlabplugins/filter_mutualglobal
		meshlabplugins/filter_mutualinfo
		meshlabplugins/filter_parametrization
		meshlabplugins/filter_plymc
		meshlabplugins/filter_qhull
		meshlabplugins/filter_quality
		meshlabplugins/filter_sampling
		meshlabplugins/filter_screened_poisson
		meshlabplugins/filter_sdfgpu
		meshlabplugins/filter_select
		meshlabplugins/filter_sketchfab
		meshlabplugins/filter_ssynth
		meshlabplugins/filter_texture
		meshlabplugins/filter_texture_defragmentation
		meshlabplugins/filter_trioptimize
		meshlabplugins/filter_unsharp
		meshlabplugins/filter_voronoi

		# Rendering and Decoration Plugins
		meshlabplugins/render_gdp
		meshlabplugins/render_radiance_scaling
		meshlabplugins/decorate_base
		meshlabplugins/decorate_background
		meshlabplugins/decorate_raster_proj
		meshlabplugins/decorate_shadow

		# Edit Plugins
		meshlabplugins/edit_sample
		meshlabplugins/edit_align
		meshlabplugins/edit_manipulators
		meshlabplugins/edit_measure
		meshlabplugins/edit_mutualcorrs
		meshlabplugins/edit_paint
		meshlabplugins/edit_pickpoints
		meshlabplugins/edit_point
		meshlabplugins/edit_referencing
		meshlabplugins/edit_quality
		meshlabplugins/edit_select
	)
endif()


message(STATUS "\nConfiguring plugins")
foreach(PLUGIN ${MESHLAB_PLUGINS})
	if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN}/CMakeLists.txt)
		message(STATUS "- ${PLUGIN}")
		add_subdirectory(${PLUGIN})
	else()
		message(STATUS "  - ${PLUGIN} - Skipping, plugin or build system not found.")
	endif()
endforeach()


### Copy/install other files

# This variable keeps track of the output filenames that need to be copied at build time
set(COPIED_FILES)

if (NOT BUILD_ONLY_MESHLAB_LIBRARIES)
	# shaders
	set(SHADER_BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders")
	file(
		GLOB_RECURSE SHADERS
		LIST_DIRECTORIES false
		"${SHADER_BASE_DIR}/*.vert"
		"${SHADER_BASE_DIR}/*.frag"
		"${SHADER_BASE_DIR}/*.gdp")
	foreach(FN ${SHADERS})
		get_filename_component(SRC_PATH ${FN} DIRECTORY)
		get_filename_component(NAME_ONLY ${FN} NAME)
		file(RELATIVE_PATH REL_DIR "${SHADER_BASE_DIR}" "${SRC_PATH}")
		set(OUTFN "${MESHLAB_SHADER_OUTPUT_DIR}/${REL_DIR}/${NAME_ONLY}")
		if(REL_DIR)
			set(REL_DIR_MESSAGE "${REL_DIR} in ")
		else()
			set(REL_DIR_MESSAGE "")
		endif()
		add_custom_command(
			OUTPUT ${OUTFN}
			COMMAND ${CMAKE_COMMAND} -E make_directory "${MESHLAB_SHADER_OUTPUT_DIR}/${REL_DIR}"
			COMMAND ${CMAKE_COMMAND} -E copy_if_different "${FN}" "${OUTFN}"
			COMMENT "Copying ${NAME_ONLY} to ${REL_DIR_MESSAGE}shader build directory"
			VERBATIM
		)
		install(
			FILES ${FN}
			DESTINATION ${MESHLAB_SHADER_INSTALL_DIR}/${REL_DIR}
			COMPONENT Shaders
		)
		list(APPEND COPIED_FILES "${OUTFN}")
	endforeach()

	# Custom target - to trigger the execution of the custom commands above.
	add_custom_target(copy-distrib-files ALL DEPENDS ${COPIED_FILES})

	set_property(TARGET copy-distrib-files PROPERTY FOLDER Core)

	# be sure to remove all plugins (also old one that are not target anymore) when clean
	set_property(
		TARGET copy-distrib-files
		APPEND
		PROPERTY ADDITIONAL_CLEAN_FILES ${MESHLAB_PLUGIN_OUTPUT_DIR}
	)

	if(NOT WIN32 AND NOT APPLE)
		install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../scripts/Linux/resources/meshlab.desktop" DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
		install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../scripts/meshlab.png" DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/512x512/apps)
	endif()

endif()

=== src/common/CMakeLists.txt ===
#version management
string(TIMESTAMP MESHLAB_VERSION "%Y.%m")

if (MESHLAB_IS_NIGHTLY_VERSION)
	# nightly version is in the form:
	# YYYY.mm[d]_nightly_GIT_SHA1
	# YYYY and mm are computed by cmake and not read from file
	find_package(Git)
	execute_process(COMMAND
		"${GIT_EXECUTABLE}" describe --match=NeVeRmAtCh --always --abbrev=7
		WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
		OUTPUT_VARIABLE GIT_SHA1
		ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
	if (BUILD_WITH_DOUBLE_SCALAR)
		set(MESHLAB_VERSION "${MESHLAB_VERSION}d")
	endif()
	set(MESHLAB_VERSION "${MESHLAB_VERSION}_nightly_${GIT_SHA1}")
else()
	if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../../ML_VERSION")
		# YYYY and mm are read from file
		file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../../ML_VERSION" MESHLAB_VERSION)
	endif()
	# if double precision version, "d" is appended
	if (BUILD_WITH_DOUBLE_SCALAR)
		set(MESHLAB_VERSION "${MESHLAB_VERSION}d")
	endif()
endif()
set(MESHLAB_VERSION ${MESHLAB_VERSION} PARENT_SCOPE)
message(STATUS "MeshLab version: ${MESHLAB_VERSION}")

if (BUILD_WITH_DOUBLE_SCALAR)
	message(STATUS "Building with double precision")
	set(MESHLAB_SCALAR "double")
else()
	message(STATUS "Building with single precision")
	set(MESHLAB_SCALAR "float")
endif()

set(HEADERS
	ml_document/helpers/mesh_document_state_data.h
	ml_document/helpers/mesh_model_state_data.h
	ml_document/base_types.h
	ml_document/cmesh.h
	ml_document/mesh_document.h
	ml_document/mesh_model.h
	ml_document/mesh_model_state.h
	ml_document/raster_model.h
	ml_document/render_raster.h
	ml_shared_data_context/ml_plugin_gl_context.h
	ml_shared_data_context/ml_scene_gl_shared_data_context.h
	ml_shared_data_context/ml_shared_data_context.h
	parameters/rich_parameter.h
	parameters/rich_parameter_list.h
	parameters/value.h
	plugins/containers/generic_container_iterator.h
	plugins/containers/decorate_plugin_container.h
	plugins/containers/edit_plugin_container.h
	plugins/containers/filter_plugin_container.h
	plugins/containers/io_plugin_container.h
	plugins/containers/render_plugin_container.h
	plugins/interfaces/meshlab_plugin.h
	plugins/interfaces/meshlab_plugin_logger.h
	plugins/interfaces/decorate_plugin.h
	plugins/interfaces/edit_plugin.h
	plugins/interfaces/filter_plugin.h
	plugins/interfaces/io_plugin.h
	plugins/interfaces/render_plugin.h
	plugins/action_searcher.h
	plugins/meshlab_plugin_type.h
	plugins/plugin_manager.h
	python/function.h
	python/function_parameter.h
	python/function_set.h
	python/python_utils.h
	utilities/eigen_mesh_conversions.h
	utilities/file_format.h
	utilities/load_save.h
	globals.h
	GLExtensionsManager.h
	GLLogStream.h
	filterscript.h
	ml_selection_buffers.h
	ml_thread_safe_memory_info.h
	mlapplication.h
	mlexception.h)

set(SOURCES
	ml_document/helpers/mesh_document_state_data.cpp
	ml_document/cmesh.cpp
	ml_document/mesh_document.cpp
	ml_document/mesh_model.cpp
	ml_document/mesh_model_state.cpp
	ml_document/raster_model.cpp
	ml_document/render_raster.cpp
	ml_shared_data_context/ml_plugin_gl_context.cpp
	ml_shared_data_context/ml_scene_gl_shared_data_context.cpp
	ml_shared_data_context/ml_shared_data_context.cpp
	parameters/rich_parameter.cpp
	parameters/rich_parameter_list.cpp
	parameters/value.cpp
	plugins/containers/decorate_plugin_container.cpp
	plugins/containers/edit_plugin_container.cpp
	plugins/containers/filter_plugin_container.cpp
	plugins/containers/io_plugin_container.cpp
	plugins/containers/render_plugin_container.cpp
	plugins/interfaces/meshlab_plugin_logger.cpp
	plugins/interfaces/decorate_plugin.cpp
	plugins/interfaces/filter_plugin.cpp
	plugins/interfaces/io_plugin.cpp
	plugins/action_searcher.cpp
	plugins/meshlab_plugin_type.cpp
	plugins/plugin_manager.cpp
	python/function.cpp
	python/function_parameter.cpp
	python/function_set.cpp
	python/python_utils.cpp
	utilities/eigen_mesh_conversions.cpp
	utilities/load_save.cpp
	globals.cpp
	GLExtensionsManager.cpp
	GLLogStream.cpp
	filterscript.cpp
	ml_selection_buffers.cpp
	ml_thread_safe_memory_info.cpp
	mlapplication.cpp)

set(RESOURCES meshlab-common.qrc)

set(TARGET_TYPE SHARED)
add_library(meshlab-common ${TARGET_TYPE} ${SOURCES} ${HEADERS} ${RESOURCES})

target_compile_definitions(meshlab-common
	PUBLIC
		MESHLAB_VERSION=${MESHLAB_VERSION}
		MESHLAB_SCALAR=${MESHLAB_SCALAR})

target_include_directories(meshlab-common
	PUBLIC
		${CMAKE_CURRENT_SOURCE_DIR}/..)

target_link_libraries(
	meshlab-common
	PUBLIC
		Qt5::Core
		Qt5::OpenGL
		Qt5::Widgets
		Qt5::Xml
		Qt5::Network
		vcglib
		external-glew
		external-exif
)

set_property(TARGET meshlab-common PROPERTY FOLDER Core)

set_property(TARGET meshlab-common
	PROPERTY RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_LIB_OUTPUT_DIR})

set_property(TARGET meshlab-common
	PROPERTY LIBRARY_OUTPUT_DIRECTORY ${MESHLAB_LIB_OUTPUT_DIR})

if (WIN32)
	target_compile_definitions(meshlab-common PRIVATE ML_EXPORT_SYMBOLS)
	set_property(TARGET meshlab-common
		PROPERTY ARCHIVE_OUTPUT_DIRECTORY ${MESHLAB_LIB_OUTPUT_DIR})
endif()

if(ENABLE_MESHLAB_DEBUG_LOG_FILE)
	target_compile_definitions(meshlab-common PUBLIC MESHLAB_LOG_FILE_ENABLED)
endif()

set_target_properties(meshlab-common PROPERTIES
	INSTALL_RPATH "${MESHLAB_LIB_INSTALL_DIR}:${INSTALL_RPATH}")

install(TARGETS meshlab-common DESTINATION ${MESHLAB_LIB_INSTALL_DIR})

=== src/external/CMakeLists.txt ===
# Copyright 2019, 2020, Collabora, Ltd.
# Copyright 2019, 2020, Visual Computing Lab, ISTI - Italian National Research Council
# SPDX-License-Identifier: BSL-1.0

option(
	ALLOW_OPTIONAL_EXTERNAL_MESHLAB_LIBRARIES
	"Allow to use/build optional external libraries"
	ON)

option(
	BUILD_BUNDLED_SOURCES_WITHOUT_WARNINGS
	"Should warnings be disabled on bundled source code?"
	ON)

add_library(external-disable-warnings INTERFACE)
if(BUILD_BUNDLED_SOURCES_WITHOUT_WARNINGS)
	if(MSVC)
		# TODO
	elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
		target_compile_options(external-disable-warnings INTERFACE -w)
	endif()
endif()

## REQUIRED EXTERNAL LIBS ##

# GLEW - required
include(${CMAKE_CURRENT_SOURCE_DIR}/glew.cmake)

# EasyExif - required
include(${CMAKE_CURRENT_SOURCE_DIR}/easyexif.cmake)


## OPTIONAL EXTERNAL LIBS ##

if ((NOT BUILD_MESHLAB_MINI) AND ALLOW_OPTIONAL_EXTERNAL_MESHLAB_LIBRARIES)

	message(STATUS "Searching for optional components")

	# boost - optional for filter_mesh_booleans
	include(${CMAKE_CURRENT_SOURCE_DIR}/boost.cmake)

	# cgal - optional for filter_mesh_booleans
	include(${CMAKE_CURRENT_SOURCE_DIR}/cgal.cmake)

	# levmar - optional, for several plugins
	include(${CMAKE_CURRENT_SOURCE_DIR}/levmar.cmake)

	# lib3ds - optional, for io_3ds
	include(${CMAKE_CURRENT_SOURCE_DIR}/lib3ds.cmake)

	# libigl - optional for filter_mesh_booleans
	include(${CMAKE_CURRENT_SOURCE_DIR}/libigl.cmake)

	# muparser - optional, for filter_func
	include(${CMAKE_CURRENT_SOURCE_DIR}/muparser.cmake)

	# nexus - optional. for io_nxs
	include(${CMAKE_CURRENT_SOURCE_DIR}/nexus.cmake)

	# newuoa - optional and header-only, for several plugins including all that use levmar
	include(${CMAKE_CURRENT_SOURCE_DIR}/newuoa.cmake)

	# OpenCTM - optional, for io_ctm
	include(${CMAKE_CURRENT_SOURCE_DIR}/openctm.cmake)

	# qhull - optional, for filter_qhull
	include(${CMAKE_CURRENT_SOURCE_DIR}/qhull.cmake)

	# structure-synth - optional, for filter_ssynth
	include(${CMAKE_CURRENT_SOURCE_DIR}/ssynth.cmake)

	# tiny glTF - optional, for io_gltf
	include(${CMAKE_CURRENT_SOURCE_DIR}/tinygltf.cmake)

	# u3d - optional, for io_u3d
	include(${CMAKE_CURRENT_SOURCE_DIR}/u3d.cmake)

	# xerces library - optional, needed by libe57
	include(${CMAKE_CURRENT_SOURCE_DIR}/xerces.cmake)

	# libe57Format - optional, for io_e57
	include(${CMAKE_CURRENT_SOURCE_DIR}/e57.cmake)

endif()

=== src/meshlab/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

set(SOURCES
	additionalgui.cpp
	glarea.cpp
	glarea_setting.cpp
	layerDialog.cpp
	main.cpp
	mainwindow_Init.cpp
	mainwindow_RunTime.cpp
	ml_default_decorators.cpp
	ml_render_gui.cpp
	ml_rendering_actions.cpp
	multiViewer_Container.cpp
	dialogs/about_dialog.cpp
	dialogs/congrats_dialog.cpp
	dialogs/filter_dock_dialog.cpp
	dialogs/filter_script_dialog.cpp
	dialogs/options_dialog.cpp
	dialogs/plugin_info_dialog.cpp
	dialogs/save_mesh_attributes_dialog.cpp
	dialogs/save_snapshot_dialog.cpp
	dialogs/setting_dialog.cpp
	gui_utils/clickable_label.cpp
	gui_utils/vertical_scroll_area.cpp
	rich_parameter_gui/richparameterlistdialog.cpp
	rich_parameter_gui/richparameterlistframe.cpp
	rich_parameter_gui/richparameterwidgets.cpp
	${VCGDIR}/wrap/gui/trackball.cpp
	${VCGDIR}/wrap/gui/trackmode.cpp
	${VCGDIR}/wrap/gui/coordinateframe.cpp)

set(HEADERS
	additionalgui.h
	glarea.h
	glarea_setting.h
	layerDialog.h
	mainwindow.h
	ml_default_decorators.h
	ml_render_gui.h
	ml_rendering_actions.h
	multiViewer_Container.h
	snapshotsetting.h
	dialogs/about_dialog.h
	dialogs/congrats_dialog.h
	dialogs/filter_dock_dialog.h
	dialogs/filter_script_dialog.h
	dialogs/options_dialog.h
	dialogs/plugin_info_dialog.h
	dialogs/save_mesh_attributes_dialog.h
	dialogs/save_snapshot_dialog.h
	dialogs/setting_dialog.h
	gui_utils/clickable_label.h
	gui_utils/vertical_scroll_area.h
	rich_parameter_gui/richparameterlistdialog.h
	rich_parameter_gui/richparameterlistframe.h
	rich_parameter_gui/richparameterwidgets.h
	${VCGDIR}/wrap/gui/trackball.h
	${VCGDIR}/wrap/gui/trackmode.h
	${VCGDIR}/wrap/gl/trimesh.h)

set(RESOURCES meshlab.qrc)

set(UI
	dialogs/about_dialog.ui
	dialogs/congrats_dialog.ui
	dialogs/filter_dock_dialog.ui
	dialogs/filter_script_dialog.ui
	dialogs/plugin_info_dialog.ui
	dialogs/save_mesh_attributes_dialog.ui
	dialogs/save_snapshot_dialog.ui
	ui/layerDialog.ui)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_CURRENT_SOURCE_DIR}/ui)

if(WIN32)
	list(APPEND SOURCES meshlab.rc)
endif()

add_executable(meshlab WIN32 MACOSX_BUNDLE
	${SOURCES} ${HEADERS} ${RESOURCES}
	${UI})

target_compile_definitions(meshlab PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x000000)
target_include_directories(meshlab PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(
	meshlab
	PUBLIC meshlab-common OpenGL::GLU Qt5::Network
	)

set_property(TARGET meshlab PROPERTY FOLDER Core)
if (APPLE)
	set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/images/meshlab.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/images/meshlab.icns DESTINATION "${MESHLAB_BUILD_DISTRIB_DIR}/meshlab.app/Contents/Resources/")
	set_target_properties(meshlab PROPERTIES 
		MACOSX_BUNDLE_ICON_FILE meshlab.icns
		MACOSX_BUNDLE_BUNDLE_VERSION "${MESHLAB_VERSION}"
		MACOSX_BUNDLE_SHORT_VERSION_STRING "${MESHLAB_VERSION}"
		MACOSX_BUNDLE_INFO_STRING "MeshLab ${MESHLAB_VERSION}"
		MACOSX_BUNDLE_COPYRIGHT "Copyright VCG-ISTI-CNR © 2005-2021. All rights reserved."
		)
	
	set_additional_settings_info_plist(
		TARGET meshlab
		FILE ${MESHLAB_BUILD_DISTRIB_DIR}/meshlab.app/Contents/Info.plist)
endif()

install(
	TARGETS meshlab
	DESTINATION ${MESHLAB_BIN_INSTALL_DIR}
	COMPONENT MeshLab)

=== src/use_cpu_opengl/CMakeLists.txt ===
# This project is supposed to be compiled only with windows.
# It creates a binary file inside the MESHLAB_DISTRIB folder that is called
# UseCPUOpenGL. This binary file is automatically run by meshlab
# only if glewInit() fails (therefore, drivers do not support newer OpenGL
# versions). When UseCPUOpenGL is run, a file called "opengl32.dll" will be
# renamed/placed in the meshlab folder, overriding the system one and making meshlab
# able to start using a CPU implementation of OpenGL.

if(WIN32)

set(SOURCES
	main.cpp
)

set(RESOURCES 
	res.qrc
)

add_executable(UseCPUOpenGL ${SOURCES} ${RESOURCES})

target_link_libraries(
        UseCPUOpenGL
        PUBLIC Qt5::Core
               Qt5::Widgets
)

set_target_properties(UseCPUOpenGL PROPERTIES LINK_FLAGS "/MANIFESTUAC:level=\'requireAdministrator\'")

install(TARGETS UseCPUOpenGL DESTINATION ${MESHLAB_BIN_INSTALL_DIR})

endif()

=== src/vcglib/CMakeLists.txt ===
# Copyright 2019, 2020, Collabora, Ltd.
# Copyright 2019, 2021, Visual Computing Lab, ISTI - Italian National Research Council
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.10)
project(VCGLib)

# Eigen options
option(ALLOW_BUNDLED_EIGEN "Allow use of bundled Eigen source" ON)
option(ALLOW_SYSTEM_EIGEN "Allow use of system-provided Eigen" ON)

# VCG options
option(VCG_HEADER_ONLY "Use VCG library in header only mode" ON)
option(VCG_BUILD_EXAMPLES "Build a set of examples of the library" OFF)

set (VCG_INCLUDE_DIRS ${CMAKE_CURRENT_LIST_DIR})
set (VCG_INCLUDE_DIRS ${CMAKE_CURRENT_LIST_DIR} PARENT_SCOPE)

### Build settings
set(CMAKE_CXX_STANDARD 11)

### Eigen
set(VCG_EIGEN_DIR ${CMAKE_CURRENT_LIST_DIR}/eigenlib)

if(ALLOW_SYSTEM_EIGEN AND EIGEN3_INCLUDE_DIR)
	message(STATUS "- Eigen - using system-provided library")
	set(EIGEN_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
elseif(ALLOW_BUNDLED_EIGEN AND EXISTS "${VCG_EIGEN_DIR}/Eigen/Eigen")
	message(STATUS "- Eigen - using bundled source")
	set(EIGEN_INCLUDE_DIRS ${VCG_EIGEN_DIR})
else()
	message(
			FATAL_ERROR
			"Eigen is required - at least one of ALLOW_SYSTEM_EIGEN or ALLOW_BUNDLED_EIGEN must be enabled and found.")
endif()

### VCGLib headers and sources

set(VCG_HEADERS
		vcg/complex/append.h
		vcg/complex/all_types.h
		vcg/complex/complex.h
		vcg/complex/allocate.h
		vcg/complex/exception.h
		vcg/complex/algorithms/overlap_estimation.h
		vcg/complex/algorithms/dual_meshing.h
		vcg/complex/algorithms/intersection.h
		vcg/complex/algorithms/clip.h
		vcg/complex/algorithms/geodesic.h
		vcg/complex/algorithms/parametrization/poisson_solver.h
		vcg/complex/algorithms/parametrization/uv_utils.h
		vcg/complex/algorithms/parametrization/distortion.h
		vcg/complex/algorithms/parametrization/tangent_field_operators.h
		vcg/complex/algorithms/parametrization/voronoi_atlas.h
		vcg/complex/algorithms/edge_collapse.h
		vcg/complex/algorithms/hole.h
		vcg/complex/algorithms/align_pair.h
		vcg/complex/algorithms/closest.h
		vcg/complex/algorithms/tetra_implicit_smooth.h
		vcg/complex/algorithms/bitquad_support.h
		vcg/complex/algorithms/skeleton.h
		vcg/complex/algorithms/symmetry.h
		vcg/complex/algorithms/voronoi_volume_sampling.h
		vcg/complex/algorithms/polygon_polychord_collapse.h
		vcg/complex/algorithms/inside.h
		vcg/complex/algorithms/local_optimization/tri_edge_flip.h
		vcg/complex/algorithms/local_optimization/quad_diag_collapse.h
		vcg/complex/algorithms/local_optimization/tri_edge_collapse_quadric.h
		vcg/complex/algorithms/local_optimization/tri_edge_collapse_quadric_tex.h
		vcg/complex/algorithms/local_optimization/tri_edge_collapse.h
		vcg/complex/algorithms/local_optimization/tetra_edge_collapse.h
		vcg/complex/algorithms/polygonal_algorithms.h
		vcg/complex/algorithms/inertia.h
		vcg/complex/algorithms/mesh_assert.h
		vcg/complex/algorithms/occupancy_grid.h
		vcg/complex/algorithms/meshtree.h
		vcg/complex/algorithms/align_global.h
		vcg/complex/algorithms/cut_tree.h
		vcg/complex/algorithms/nring.h
		vcg/complex/algorithms/tetra/tetfuse_collapse.h
		vcg/complex/algorithms/stat.h
		vcg/complex/algorithms/ransac_matching.h
		vcg/complex/algorithms/refine.h
		vcg/complex/algorithms/outline_support.h
		vcg/complex/algorithms/convex_hull.h
		vcg/complex/algorithms/clean.h
		vcg/complex/algorithms/mesh_to_matrix.h
		vcg/complex/algorithms/quadrangulator.h
		vcg/complex/algorithms/isotropic_remeshing.h
		vcg/complex/algorithms/smooth.h
		vcg/complex/algorithms/autoalign_4pcs.h
		vcg/complex/algorithms/local_optimization.h
		vcg/complex/algorithms/curve_on_manifold.h
		vcg/complex/algorithms/clustering.h
		vcg/complex/algorithms/refine_loop.h
		vcg/complex/algorithms/cylinder_clipping.h
		vcg/complex/algorithms/pointcloud_normal.h
		vcg/complex/algorithms/bitquad_creation.h
		vcg/complex/algorithms/crease_cut.h
		vcg/complex/algorithms/implicit_smooth.h
		vcg/complex/algorithms/voronoi_remesher.h
		vcg/complex/algorithms/polygon_support.h
		vcg/complex/algorithms/point_sampling.h
		vcg/complex/algorithms/create/mc_lookup_table.h
		vcg/complex/algorithms/create/mc_trivial_walker.h
		vcg/complex/algorithms/create/extrude.h
		vcg/complex/algorithms/create/resampler.h
		vcg/complex/algorithms/create/ball_pivoting.h
		vcg/complex/algorithms/create/readme.txt
		vcg/complex/algorithms/create/zonohedron.h
		vcg/complex/algorithms/create/platonic.h
		vcg/complex/algorithms/create/marching_cubes.h
		vcg/complex/algorithms/create/plymc/voxel.h
		vcg/complex/algorithms/create/plymc/simplemeshprovider.h
		vcg/complex/algorithms/create/plymc/tri_edge_collapse_mc.h
		vcg/complex/algorithms/create/plymc/volume.h
		vcg/complex/algorithms/create/plymc/plymc.h
		vcg/complex/algorithms/create/plymc/svoxel.h
		vcg/complex/algorithms/create/tetramesh_support.h
		vcg/complex/algorithms/create/advancing_front.h
		vcg/complex/algorithms/textcoord_optimization.h
		vcg/complex/algorithms/bitquad_optimization.h
		vcg/complex/algorithms/halfedge_quad_clean.h
		vcg/complex/algorithms/voronoi_processing.h
		vcg/complex/algorithms/update/quality.h
		vcg/complex/algorithms/update/selection.h
		vcg/complex/algorithms/update/fitmaps.h
		vcg/complex/algorithms/update/component_ep.h
		vcg/complex/algorithms/update/texture.h
		vcg/complex/algorithms/update/curvature_fitting.h
		vcg/complex/algorithms/update/normal.h
		vcg/complex/algorithms/update/position.h
		vcg/complex/algorithms/update/halfedge_topology.h
		vcg/complex/algorithms/update/topology.h
		vcg/complex/algorithms/update/flag.h
		vcg/complex/algorithms/update/bounding.h
		vcg/complex/algorithms/update/halfedge_indexed.h
		vcg/complex/algorithms/update/color.h
		vcg/complex/algorithms/update/curvature.h
		vcg/complex/algorithms/point_outlier.h
		vcg/complex/algorithms/harmonic.h
		vcg/complex/algorithms/point_matching_scale.h
		vcg/complex/algorithms/attribute_seam.h
		vcg/complex/foreach.h
		vcg/complex/base.h
		vcg/complex/used_types.h
		vcg/container/entries_allocation_table.h
		vcg/container/container_allocation_table.h
		vcg/container/derivation_chain.h
		vcg/container/vector_occ.h
		vcg/container/simple_temporary_data.h
		vcg/space/segment2.h
		vcg/space/fitting3.h
		vcg/space/tetra3.h
		vcg/space/triangle2.h
		vcg/space/ray2.h
		vcg/space/deprecated_point2.h
		vcg/space/point4.h
		vcg/space/box2.h
		vcg/space/ray3.h
		vcg/space/planar_polygon_tessellation.h
		vcg/space/texcoord2.h
		vcg/space/deprecated_point3.h
		vcg/space/intersection/triangle_triangle3.h
		vcg/space/distance2.h
		vcg/space/point3.h
		vcg/space/deprecated_point.h
		vcg/space/space.h
		vcg/space/point.h
		vcg/space/colorspace.h
		vcg/space/rect_packer.h
		vcg/space/triangle3.h
		vcg/space/obox3.h
		vcg/space/point2.h
		vcg/space/smallest_enclosing.h
		vcg/space/color4.h
		vcg/space/polygon3.h
		vcg/space/line3.h
		vcg/space/index/octree.h
		vcg/space/index/grid_util2d.h
		vcg/space/index/grid_closest.h
		vcg/space/index/grid_static_ptr.h
		vcg/space/index/grid_util.h
		vcg/space/index/spatial_hashing.h
		vcg/space/index/closest2d.h
		vcg/space/index/grid_static_obj.h
		vcg/space/index/kdtree/kdtree.h
		vcg/space/index/kdtree/priorityqueue.h
		vcg/space/index/kdtree/kdtree_face.h
		vcg/space/index/kdtree/mlsutils.h
		vcg/space/index/octree_template.h
		vcg/space/index/aabb_binary_tree/kclosest.h
		vcg/space/index/aabb_binary_tree/closest.h
		vcg/space/index/aabb_binary_tree/ray.h
		vcg/space/index/aabb_binary_tree/frustum_cull.h
		vcg/space/index/aabb_binary_tree/aabb_binary_tree.h
		vcg/space/index/aabb_binary_tree/base.h
		vcg/space/index/grid_closest2d.h
		vcg/space/index/spatial_hashing2d.h
		vcg/space/index/space_iterators.h
		vcg/space/index/grid_static_ptr2d.h
		vcg/space/index/base2d.h
		vcg/space/index/base.h
		vcg/space/index/perfect_spatial_hashing.h
		vcg/space/index/space_iterators2d.h
		vcg/space/line2.h
		vcg/space/point_matching.h
		vcg/space/intersection3.h
		vcg/space/deprecated_point4.h
		vcg/space/rasterized_outline2_packer.h
		vcg/space/box.h
		vcg/space/plane3.h
		vcg/space/outline2_packer.h
		vcg/space/segment3.h
		vcg/space/intersection2.h
		vcg/space/sphere3.h
		vcg/space/box3.h
		vcg/space/distance3.h
		vcg/math/quadric5.h
		vcg/math/factorial.h
		vcg/math/eigen_matrix_addons.h
		vcg/math/quadric.h
		vcg/math/perlin_noise.h
		vcg/math/shot.h
		vcg/math/spherical_harmonics.h
		vcg/math/eigen_matrixbase_addons.h
		vcg/math/quaternion.h
		vcg/math/similarity.h
		vcg/math/disjoint_set.h
		vcg/math/random_generator.h
		vcg/math/camera.h
		vcg/math/linear.h
		vcg/math/matrix44.h
		vcg/math/eigen.h
		vcg/math/similarity2.h
		vcg/math/gen_normal.h
		vcg/math/polar_decomposition.h
		vcg/math/base.h
		vcg/math/histogram.h
		vcg/math/legendre.h
		vcg/math/matrix33.h
		vcg/simplex/edge/distance.h
		vcg/simplex/edge/topology.h
		vcg/simplex/edge/pos.h
		vcg/simplex/edge/component.h
		vcg/simplex/edge/base.h
		vcg/simplex/tetrahedron/tetrahedron.h
		vcg/simplex/tetrahedron/topology.h
		vcg/simplex/tetrahedron/pos.h
		vcg/simplex/tetrahedron/component.h
		vcg/simplex/tetrahedron/base.h
		vcg/simplex/face/component_occ.h
		vcg/simplex/face/component_ep.h
		vcg/simplex/face/jumping_pos.h
		vcg/simplex/face/distance.h
		vcg/simplex/face/component_polygon.h
		vcg/simplex/face/topology.h
		vcg/simplex/face/pos.h
		vcg/simplex/face/component.h
		vcg/simplex/face/component_ocf.h
		vcg/simplex/face/base.h
		vcg/simplex/vertex/component_occ.h
		vcg/simplex/vertex/component_sph.h
		vcg/simplex/vertex/distance.h
		vcg/simplex/vertex/component.h
		vcg/simplex/vertex/component_ocf.h
		vcg/simplex/vertex/base.h
		vcg/connectors/halfedge_pos.h
		vcg/connectors/hedge.h
		vcg/connectors/hedge_component.h

		#wrap
		wrap/callback.h
		)

set(SOURCES
		)

if (VCG_HEADER_ONLY)
	if (NOT TARGET vcglib) # to be sure that vcglib target is created just one time
		add_library(vcglib INTERFACE)
		target_include_directories(
				vcglib INTERFACE
				${CMAKE_CURRENT_LIST_DIR}
				${EIGEN_INCLUDE_DIRS})

		#just to show headers in ide
		add_custom_target(vcglib_ide SOURCES ${VCG_HEADERS})
	else()
		message(STATUS "- VCGLib - jumped - already included")
	endif()
else()
	#TODO make vcglib that includes all the wrap sources, checking everytime
	# if the the required targets (e.g. qt, gl, glew...) exists
endif()

if(VCG_BUILD_EXAMPLES)
	#TODO make the list of samples to build
	add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/apps)
endif()

=== src/external/libigl-2.3.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# Toggles the use of the hunter package manager
option(HUNTER_ENABLED "Enable Hunter package manager support" OFF)

include("cmake/HunterGate.cmake")
HunterGate(
	URL "https://github.com/ruslo/hunter/archive/v0.23.171.tar.gz"
	SHA1 "5d68bcca78eee347239ca5f4d34f4b6c12683154"
)

project(libigl)

# Detects whether this is a top-level project
get_directory_property(LIBIGL_PARENT_DIR PARENT_DIRECTORY)
if(NOT LIBIGL_PARENT_DIR)
	set(LIBIGL_TOPLEVEL_PROJECT ON)
else()
	set(LIBIGL_TOPLEVEL_PROJECT OFF)
endif()

# Build tests and tutorials
option(LIBIGL_BUILD_TESTS      "Build libigl unit test"        ${LIBIGL_TOPLEVEL_PROJECT})
option(LIBIGL_BUILD_TUTORIALS  "Build libigl tutorial"         ${LIBIGL_TOPLEVEL_PROJECT})
option(LIBIGL_EXPORT_TARGETS   "Export libigl CMake targets"   ${LIBIGL_TOPLEVEL_PROJECT})

# USE_STATIC_LIBRARY speeds up the generation of multiple binaries,
# at the cost of a longer initial compilation time
# (by default, static build is off since libigl is a header-only library)
option(LIBIGL_USE_STATIC_LIBRARY "Use libigl as static library" ON)

# All dependencies that are downloaded as cmake projects and tested on the auto-builds are ON
# (by default, all build options are off)
option(LIBIGL_WITH_COMISO            "Use CoMiso"                   ON)
option(LIBIGL_WITH_EMBREE            "Use Embree"                   ON)
option(LIBIGL_WITH_OPENGL            "Use OpenGL"                   ON)
option(LIBIGL_WITH_OPENGL_GLFW       "Use GLFW"                     ON)
option(LIBIGL_WITH_OPENGL_GLFW_IMGUI "Use ImGui"                    ON)
option(LIBIGL_WITH_PNG               "Use PNG"                      ON)
option(LIBIGL_WITH_TETGEN            "Use Tetgen"                   ON)
option(LIBIGL_WITH_TRIANGLE          "Use Triangle"                 ON)
option(LIBIGL_WITH_PREDICATES        "Use exact predicates"         ON)
option(LIBIGL_WITH_XML               "Use XML"                      ON)
option(LIBIGL_WITH_PYTHON            "Use Python"                   OFF)
### End

if(${LIBIGL_WITH_PYTHON})
	message(FATAL_ERROR "Python binding are in the process of being redone. Please use the master branch or refer to https://github.com/geometryprocessing/libigl-python-bindings for the developement version or https://anaconda.org/conda-forge/igl for the stable version.")
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

### conditionally compile certain modules depending on libraries found on the system
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

### Adding libIGL: choose the path to your local copy libIGL
include(libigl)

if(LIBIGL_BUILD_TUTORIALS)
	add_subdirectory(tutorial)
endif()

if(LIBIGL_BUILD_TESTS)
	include(CTest)
	enable_testing()
	add_subdirectory(tests)
endif()

if(LIBIGL_TOPLEVEL_PROJECT)
	# Set folders for Visual Studio/Xcode
	igl_set_folders()
endif()

=== src/external/u3d/CMakeLists.txt ===
set (U3D_DIR ${CMAKE_CURRENT_SOURCE_DIR})

IF(APPLE)
	ADD_DEFINITIONS( -DMAC32 -fno-strict-aliasing )
	SET( U3D_PLATFORM Mac32 )
ENDIF(APPLE)

IF(WIN32)
	ADD_DEFINITIONS( -DUNICODE -D_UNICODE -D_CRT_SECURE_NO_DEPRECATE )
	SET( U3D_PLATFORM Win32 )
	LINK_LIBRARIES( winmm )
	UNSET( CMAKE_SHARED_LIBRARY_PREFIX )
	UNSET( CMAKE_SHARED_MODULE_PREFIX )
	UNSET( CMAKE_STATIC_LIBRARY_PREFIX )
	UNSET( CMAKE_IMPORT_LIBRARY_PREFIX )
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
	ADD_DEFINITIONS( -DLIN32 -fno-strict-aliasing )
	SET( U3D_PLATFORM Lin32 )
ENDIF(UNIX AND NOT APPLE)

#============================================================================
# zlib
#============================================================================

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
	add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
	add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
	add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

SET(ZLIB_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/zlib)
#configure_file(${ZLIB_SOURCE_DIR}/zconf.h.cmakein
#			   ${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)
#include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${ZLIB_SOURCE_DIR})

set(ZLIB_PUBLIC_HDRS
	${ZLIB_SOURCE_DIR}/zconf.h
	${ZLIB_SOURCE_DIR}/zlib.h
)
set(ZLIB_PRIVATE_HDRS
	${ZLIB_SOURCE_DIR}/zconf.h
	${ZLIB_SOURCE_DIR}/crc32.h
	${ZLIB_SOURCE_DIR}/deflate.h
	${ZLIB_SOURCE_DIR}/gzguts.h
	${ZLIB_SOURCE_DIR}/inffast.h
	${ZLIB_SOURCE_DIR}/inffixed.h
	${ZLIB_SOURCE_DIR}/inflate.h
	${ZLIB_SOURCE_DIR}/inftrees.h
	${ZLIB_SOURCE_DIR}/trees.h
	${ZLIB_SOURCE_DIR}/zutil.h
)
set(ZLIB_SRCS
	${ZLIB_SOURCE_DIR}/adler32.c
	${ZLIB_SOURCE_DIR}/compress.c
	${ZLIB_SOURCE_DIR}/crc32.c
	${ZLIB_SOURCE_DIR}/deflate.c
	${ZLIB_SOURCE_DIR}/gzclose.c
	${ZLIB_SOURCE_DIR}/gzlib.c
	${ZLIB_SOURCE_DIR}/gzread.c
	${ZLIB_SOURCE_DIR}/gzwrite.c
	${ZLIB_SOURCE_DIR}/inflate.c
	${ZLIB_SOURCE_DIR}/infback.c
	${ZLIB_SOURCE_DIR}/inftrees.c
	${ZLIB_SOURCE_DIR}/inffast.c
	${ZLIB_SOURCE_DIR}/trees.c
	${ZLIB_SOURCE_DIR}/uncompr.c
	${ZLIB_SOURCE_DIR}/zutil.c
)


#============================================================================
# png
#============================================================================

if(NOT WIN32)
	find_library(M_LIBRARY
		NAMES m
		PATHS /usr/lib /usr/local/lib)
	if(NOT M_LIBRARY)
	message(STATUS
		"math library 'libm' not found - floating point support disabled")
	endif()
else()
	# not needed on windows
	set(M_LIBRARY "")
endif()

set(PNG_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/png)
#include_directories(${CMAKE_CURRENT_BINARY_DIR})

# OUR SOURCES
set(libpng_public_hdrs
	${PNG_SOURCE_DIR}/png.h
	${PNG_SOURCE_DIR}/pngconf.h
	${PNG_SOURCE_DIR}/pnglibconf.h
)
set(libpng_sources
	${libpng_public_hdrs}
	${PNG_SOURCE_DIR}/pngdebug.h
	${PNG_SOURCE_DIR}/pnginfo.h
	${PNG_SOURCE_DIR}/pngpriv.h
	${PNG_SOURCE_DIR}/pngstruct.h
	${PNG_SOURCE_DIR}/png.c
	${PNG_SOURCE_DIR}/pngerror.c
	${PNG_SOURCE_DIR}/pngget.c
	${PNG_SOURCE_DIR}/pngmem.c
	${PNG_SOURCE_DIR}/pngpread.c
	${PNG_SOURCE_DIR}/pngread.c
	${PNG_SOURCE_DIR}/pngrio.c
	${PNG_SOURCE_DIR}/pngrtran.c
	${PNG_SOURCE_DIR}/pngrutil.c
	${PNG_SOURCE_DIR}/pngset.c
	${PNG_SOURCE_DIR}/pngtrans.c
	${PNG_SOURCE_DIR}/pngwio.c
	${PNG_SOURCE_DIR}/pngwrite.c
	${PNG_SOURCE_DIR}/pngwtran.c
	${PNG_SOURCE_DIR}/pngwutil.c
)
# SOME NEEDED DEFINITIONS

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
endif(MSVC)

set(ADDITIONAL_LIBRARIES ${ADDITIONAL_LIBRARIES} ${M_LIBRARY})
include_directories(${PNG_SOURCE_DIR})

CHECK_INCLUDE_FILE(stdlib.h HAVE_STDLIB_H)

set(JPEG_SOURCE_DIR ${U3D_DIR}/src/RTL/Dependencies/jpeg)
#configure_file(${JPEG_SOURCE_DIR}/jconfig.h.cmake
#			   ${CMAKE_CURRENT_BINARY_DIR}/jconfig.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${JPEG_SOURCE_DIR})

if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

set(JPEG_PUBLIC_HDRS
	${JPEG_SOURCE_DIR}/jconfig.h
	${JPEG_SOURCE_DIR}/jerror.h
	${JPEG_SOURCE_DIR}/jmorecfg.h
	${JPEG_SOURCE_DIR}/jpeglib.h
	${JPEG_SOURCE_DIR}/jconfig.h
)
set(JPEG_PRIVATE_HDRS
	${JPEG_SOURCE_DIR}/cderror.h
	${JPEG_SOURCE_DIR}/jdct.h
	${JPEG_SOURCE_DIR}/jinclude.h
	${JPEG_SOURCE_DIR}/jmemsys.h
	${JPEG_SOURCE_DIR}/jpegint.h
	${JPEG_SOURCE_DIR}/jversion.h
	${JPEG_SOURCE_DIR}/transupp.h
)

# memmgr back ends: compile only one of these into a working library
# (For now, let's use the mode that requires the image fit into memory.
# This is the recommended mode for Win32 anyway.)
SET(JPEG_systemdependent_SRCS ${JPEG_SOURCE_DIR}/jmemnobs.c)

set(JPEG_SRCS
	${JPEG_SOURCE_DIR}/jaricom.c
	${JPEG_SOURCE_DIR}/jcapimin.c
	${JPEG_SOURCE_DIR}/jcapistd.c
	${JPEG_SOURCE_DIR}/jcarith.c
	${JPEG_SOURCE_DIR}/jccoefct.c
	${JPEG_SOURCE_DIR}/jccolor.c
	${JPEG_SOURCE_DIR}/jcdctmgr.c
	${JPEG_SOURCE_DIR}/jchuff.c
	${JPEG_SOURCE_DIR}/jcinit.c
	${JPEG_SOURCE_DIR}/jcmainct.c
	${JPEG_SOURCE_DIR}/jcmarker.c
	${JPEG_SOURCE_DIR}/jcmaster.c
	${JPEG_SOURCE_DIR}/jcomapi.c
	${JPEG_SOURCE_DIR}/jcparam.c
	${JPEG_SOURCE_DIR}/jcprepct.c
	${JPEG_SOURCE_DIR}/jcsample.c
	${JPEG_SOURCE_DIR}/jctrans.c
	${JPEG_SOURCE_DIR}/jdapimin.c
	${JPEG_SOURCE_DIR}/jdapistd.c
	${JPEG_SOURCE_DIR}/jdarith.c
	${JPEG_SOURCE_DIR}/jdatadst.c
	${JPEG_SOURCE_DIR}/jdatasrc.c
	${JPEG_SOURCE_DIR}/jdcoefct.c
	${JPEG_SOURCE_DIR}/jdcolor.c
	${JPEG_SOURCE_DIR}/jddctmgr.c
	${JPEG_SOURCE_DIR}/jdhuff.c
	${JPEG_SOURCE_DIR}/jdinput.c
	${JPEG_SOURCE_DIR}/jdmainct.c
	${JPEG_SOURCE_DIR}/jdmarker.c
	${JPEG_SOURCE_DIR}/jdmaster.c
	${JPEG_SOURCE_DIR}/jdmerge.c
	${JPEG_SOURCE_DIR}/jdpostct.c
	${JPEG_SOURCE_DIR}/jdsample.c
	${JPEG_SOURCE_DIR}/jdtrans.c
	${JPEG_SOURCE_DIR}/jerror.c
	${JPEG_SOURCE_DIR}/jfdctflt.c
	${JPEG_SOURCE_DIR}/jfdctfst.c
	${JPEG_SOURCE_DIR}/jfdctint.c
	${JPEG_SOURCE_DIR}/jidctflt.c
	${JPEG_SOURCE_DIR}/jidctfst.c
	${JPEG_SOURCE_DIR}/jidctint.c
	${JPEG_SOURCE_DIR}/jquant1.c
	${JPEG_SOURCE_DIR}/jquant2.c
	${JPEG_SOURCE_DIR}/jutils.c
	${JPEG_SOURCE_DIR}/jmemmgr.c)

SET(DEPENDENCIES_SRCS
	${ZLIB_SRCS}
	${ZLIB_PUBLIC_HDRS}
	${ZLIB_PRIVATE_HDRS}
	${libpng_sources}
	${JPEG_systemdependent_SRCS}
	${JPEG_SRCS}
	${JPEG_PUBLIC_HDRS}
	${JPEG_PRIVATE_HDRS})
#====


INCLUDE_DIRECTORIES(
	${U3D_DIR}/src/RTL/Component/Include
	${U3D_DIR}/src/RTL/Kernel/Include
	${U3D_DIR}/src/RTL/Platform/Include)
SET( Component_HDRS
	${U3D_DIR}/src/RTL/Component/Include/CArrayList.h
	${U3D_DIR}/src/RTL/Component/Include/DX7asDX8.h
	${U3D_DIR}/src/RTL/Component/Include/IFXACContext.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAdaptiveMetric.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAnimationModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXArray.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAttributes.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthor.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODGen.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODMesh.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorCLODResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorGeomCompiler.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetAnalyzer.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorLineSetResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMesh.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMeshMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorMeshScrub.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSetAccess.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorPointSetResource.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAuthorUpdate.h
	${U3D_DIR}/src/RTL/Component/Include/IFXAutoPtr.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBaseOpenGL.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBitStreamCompressedX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBitStreamX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlendParam.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockReaderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockTypes.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBlockWriterX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBones.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBonesManager.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoneWeightsModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundHierarchy.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundHierarchyMgr.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundingBox.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundSphereDataElement.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBoundVolume.h
	${U3D_DIR}/src/RTL/Component/Include/IFXBTTHash.h
	${U3D_DIR}/src/RTL/Component/Include/IFXClock.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCLODManagerInterface.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCLODModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoincidentVertexMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCollection.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreServices.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCoreServicesRef.h
	${U3D_DIR}/src/RTL/Component/Include/IFXCornerIter.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlock.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlockQueueX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataBlockX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDataPacket.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDecoderChainX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDecoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDeque.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDevice.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDidRegistry.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDids.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDirectX7.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDirectX8.h
	${U3D_DIR}/src/RTL/Component/Include/IFXDummyModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEncoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEnums.h
	${U3D_DIR}/src/RTL/Component/Include/IFXErrorInfo.h
	${U3D_DIR}/src/RTL/Component/Include/IFXEuler.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportingCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportingInterfaces.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExportOptions.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExtensionDecoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXExtensionEncoderX.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFace.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFastAllocator.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFastHeap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFatCornerIter.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFileReference.h
	${U3D_DIR}/src/RTL/Component/Include/IFXFrustum.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGenerator.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyph2DCommands.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyph2DModifier.h
	${U3D_DIR}/src/RTL/Component/Include/IFXGlyphCommandList.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHash.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHashMap.h
	${U3D_DIR}/src/RTL/Component/Include/IFXHistogramDynamic.h
	${U3D_DIR}/src/RTL/Component/Include/IFXIDManager.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImageCodec.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImportingCIDs.h
	${U3D_DIR}/src/RTL/Component/Include/IFXImportingInterfaces.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInet.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInstant.h
	${U3D_DIR}/src/RTL/Component/Include/IFXInterleavedData.h

=== src/meshlabplugins/decorate_background/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0


set(SOURCES cubemap.cpp decorate_background.cpp)

set(HEADERS cubemap.h decorate_background.h)

set(RESOURCES decorate_background.qrc)

add_meshlab_plugin(decorate_background ${SOURCES} ${HEADERS} ${RESOURCES})

=== src/meshlabplugins/decorate_base/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0


set(SOURCES decorate_base.cpp ${VCGDIR}/wrap/gui/coordinateframe.cpp)

set(HEADERS colorhistogram.h decorate_base.h)

set(RESOURCES decorate_base.qrc)

add_meshlab_plugin(decorate_base ${SOURCES} ${HEADERS} ${RESOURCES})

target_link_libraries(decorate_base PRIVATE OpenGL::GLU)

=== src/meshlabplugins/decorate_shadow/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0


set(SOURCES
    decorate_shadow.cpp
    shadow_mapping.cpp
    ssao.cpp
    variance_shadow_mapping.cpp
    variance_shadow_mapping_blur.cpp
    ${VCGDIR}/wrap/gui/trackball.cpp
    ${VCGDIR}/wrap/gui/trackmode.cpp)

set(HEADERS
    decorate_shader.h
    decorate_shadow.h
    shadow_mapping.h
    ssao.h
    variance_shadow_mapping.h
    variance_shadow_mapping_blur.h
    ${VCGDIR}/wrap/gui/trackball.h)

set(RESOURCES noise.qrc)

add_meshlab_plugin(decorate_shadow ${SOURCES} ${HEADERS} ${RESOURCES})

target_link_libraries(decorate_shadow PRIVATE OpenGL::GLU)

=== src/meshlabplugins/edit_align/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0


# Only build if we have newuoa
if(TARGET external-newuoa)

	set(SOURCES
		align/align_parameter.cpp

		alignDialog.cpp
		AlignPairDialog.cpp
		AlignPairWidget.cpp
		edit_align_factory.cpp
		edit_align.cpp
		../../meshlab/gui_utils/clickable_label.cpp
		../../meshlab/rich_parameter_gui/richparameterwidgets.cpp
		../../meshlab/rich_parameter_gui/richparameterlistframe.cpp
		../../meshlab/rich_parameter_gui/richparameterlistdialog.cpp
		${VCGDIR}/wrap/gui/trackball.cpp
		${VCGDIR}/wrap/gui/trackmode.cpp
		${VCGDIR}/wrap/ply/plylib.cpp)

	set(HEADERS
		align/align_parameter.h

		alignDialog.h
		AlignPairDialog.h
		AlignPairWidget.h
		edit_align_factory.h
		edit_align.h
		../../meshlab/rich_parameter_gui/richparameterwidgets.h
		../../meshlab/rich_parameter_gui/richparameterlistframe.h
		../../meshlab/rich_parameter_gui/richparameterlistdialog.h
		${VCGDIR}/wrap/gui/trackball.h
		${VCGDIR}/wrap/gui/trackmode.h
		${VCGDIR}/wrap/gl/trimesh.h)

	set(RESOURCES edit_align.qrc)

	set(UI alignDialog.ui)

	add_meshlab_plugin(edit_align ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

	target_link_libraries(edit_align PRIVATE external-newuoa OpenGL::GLU)
	if(OpenMP_CXX_FOUND)
		target_link_libraries(edit_align PRIVATE OpenMP::OpenMP_CXX)
	endif()

else()
	message(
		STATUS "Skipping edit_align - missing newuoa in external directory.")
endif()

=== debian/changelog ===
meshlab (2022.02+dfsg1-1) unstable; urgency=medium

  [ Rylie Pavlik ]
  * New upstream version 2022.02+dfsg1
    - Closes: #990401
    - meshlabserver tool removed
    - filter_csg and globalregistration plugins removed
    - filter_icp, filter_mesh_booleans, filter_texture_defragmentation,
      io_e57, and io_gltf plugins added
  * Updates for revised directory structure in newer upstream releases
  * Revise/update patches
    - Add 0008-e57-Fix-build-error-from-missing-include.patch to fix build.
    - Add 0009-Fix-spelling-errors-in-strings.patch to fix spelling errors
      in binaries.
    - Drop 0009-cmake-Search-for-use-Qt5Qml-in-a-more-graceful-absen.patch:
      Qt5Qml no longer required.
    - Drop 0010-build-Use-C99-where-available-for-large-file-support.patch:
      merged upstream.
    - Drop 16_shadersdir.patch: equivalent fixes applied upstream
    - Revise 03_disable-updates.patch.
    - Revise 22_find-plugins.patch.
  * d/copyright: Update, correct issues noticed by lintian and lrc.
  * d/control:
    - Update list of file formats in description.
    - Drop Build-Depends on libqt5xmlpatterns5-dev, qtdeclarative5-dev,
      qtscript5-dev, libbz2-dev, libchealpix-dev, libcfitsio-dev
    - Add Build-Depends on libxerces-c-dev, libcgal-dev, libboost-all-dev
  * d/rules: Update configure flags, build process, put deps from plugins
    in "Recommends" not "Depends".
  * d/get-orig-source.sh: Fix for changed tag format.
  * d/watch: Fix
  * d/source/lintian-overrides: Remove obsolete override
  * d/meshlab.lintian-overrides: Override RPATH error.
  * Use upstream's desktop file.
  * Fix reproducible builds. See: #1001870
    Thanks to Vagrant Cascadian for the patch.
  * Fix packager's name.

  [ Stuart Prescott ]
  * Update lintian overrides to new format.
  * d/rules: Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Rylie Pavlik <rylie@ryliepavlik.com>  Thu, 12 Dec 2024 10:11:53 -0600

meshlab (2020.09+dfsg1-3) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * Bump debhelper version to 13.

 -- Alex Myczko <tar@debian.org>  Thu, 18 Jul 2024 17:05:39 +0000

meshlab (2020.09+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Set C++14 explicitly. (Closes: #984232)

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Dec 2021 19:58:20 +0100

=== debian/control ===
Source: meshlab
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rylie Pavlik <rylie@ryliepavlik.com>,
           Teemu Ikonen <tpikonen@gmail.com>,
           Alex Myczko <tar@debian.org>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               lib3ds-dev,
               libboost-all-dev,
               libcgal-dev,
               libeigen3-dev,
               libglew-dev,
               libglu1-mesa-dev,
               libgmp-dev,
               libjpeg-dev,
               libmuparser-dev,
               libopenctm-dev,
               libpng-dev,
               libqhull-dev,
               libqt5opengl5-desktop-dev,
               libxerces-c-dev,
               mesa-common-dev,
               qtbase5-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/meshlab
Vcs-Git: https://salsa.debian.org/science-team/meshlab.git
Homepage: https://www.meshlab.net/
Rules-Requires-Root: no

Package: meshlab
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: chemical-mime-data,
            ${pluginshlibs:Recommends}
Description: System for processing and editing triangular meshes
 This is an open source, portable, and extendible system for the
 processing and editing of unstructured 3D triangular meshes.
 The system is aimed to help the processing of the typical not-so-small
 unstructured models arising in 3D scanning, providing a set of tools for
 editing, cleaning, healing, inspecting, rendering and converting this kind
 of meshes.
 .
 Meshlab can read and write files in a variety of formats. Supported formats
 for meshes include:
 .
 - 3DS aka 3D-Studio File Format (read/write)
 - ASC aka ascii triplets of points (read)
 - BRE aka Breuckmann File Format (read)
 - CTM aka OpenCTM compressed format (read/write)
 - DAE aka COLLADA (read/write)
 - DXF (write)
 - E57 points cloud (read/write)
 - FBX Autodesk Interchange Format(read)
 - glTF/glb aka GL Transmission Format 2.0 (binary or ascii) (read)
 - JSON (write)
 - OBJ aka Alias Wavefront Object (read/write)
 - OFF aka Object File Format (read/write)
 - PDB aka Protein Data Bank(read)
 - PLY aka Stanford Polygon File Format (read/write)
 - PTX (read)
 - QOBJ aka Quad Object (read)
 - STL (read/write)
 - TRI aka photogrammetric reconstructions (read)
 - TXT aka generic ASCII point list or image list file (read)
 - U3D/IDTF (write)
 - VMI aka VCG Dump File Format (read)
 - WRL aka VRML 2.0 (read/write)
 - X3D aka X3D in XML encoding (read/write)
 - X3DV aka X3D in VRML encoding (read)
 - XYZ Point Cloud (with or without normal) (read/write)
 - apts aka Expe's point set (ascii) (read)
 - pts aka Expe's point set (binary) (read)
 .
 Project formats include:
 .
 - MLP aka MeshLab Project (read/write)
 - MLB aka MeshLab Binary Project (read/write)
 - ALN aka Align Project (read)
 - OUT aka Bundler Output (read)
 - NVM aka VisualSFM Output (read)
 .
 A variety of image formats are also supported.
